<?php
    /*****************************************************************************
    IP Reg, a PHP/MySQL IPAM tool
    Copyright (C) 2007-2009 Wietse Warendorff

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    For more information, visit http://sourceforge.net/projects/ipreg,
    or contact me at wietsew@users.sourceforge.net
    *****************************************************************************/

    // start page
        // includes
        include("includes.php");

        // get id
        $asset_id = sanitize($_GET['asset_id']);

        // start output
        include("header.php");

        // set language variables
        $smarty->assign($lang);

    // setup asset
        // build query
        $query = "SELECT
                a.asset_name,
                a.asset_hostname,
                a.asset_info,
                c.assetclass_id,
                c.assetclass_name
            FROM
                asset AS a LEFT OUTER JOIN assetclass AS c USING (assetclass_id)
            WHERE
                a.asset_id=" . $asset_id;

        // run query
        $asset = $db->db_select($query);

        // send to tpl
        $smarty->assign("asset_id", $asset_id);
        $smarty->assign("asset_name", $asset[0]['asset_name']);
        $smarty->assign("asset_hostname", $asset[0]['asset_hostname']);
        $smarty->assign("asset_info", nl2br($asset[0]['asset_info']));

        $smarty->assign("assetclass_id", $asset[0]['assetclass_id']);
        $smarty->assign("assetclass_name", $asset[0]['assetclass_name']);

    // setup node
        // build query
        $query = "SELECT
                node_id,
                node_ip,
                LEFT(node_info, 40) as node_info
            FROM
                node
            WHERE
                asset_id=" . $asset_id . "
            ORDER BY
                INET_ATON(node_ip)";

        // run query
        $nodes = $db->db_select($query);
        $smarty->assign("nodes", $nodes);

    // end page
        // output
        $smarty->display("assetview.tpl");

        // footer
        include("footer.php");
?>
