<?php
	/*****************************************************************************
	IP Reg, a PHP/MySQL IPAM tool
	Copyright (C) 2007-2009 Wietse Warendorff
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	For more information, visit http://sourceforge.net/projects/ipreg,
	or contact me at wietsew@users.sourceforge.net
	*****************************************************************************/

	// start page
		// includes
		include("includes.php");
		
		// start output
		include("header.php");
		
		// set language variables
		$smarty->assign($lang);

	// start location
		// look for locations
			// build query
			$query = "SELECT
					location_id AS id,
					location_name AS value,
					location_parent AS parent_id
				FROM
					location
                                ORDER BY location_parent, location_sort, location_name";

			// run query
			$locations = $db->db_select($query);

            function build_tree($parent_id, $level) {
                global $locations;
                $children = array();
                foreach ($locations as $key => $location) {
                    if ($location['parent_id'] == $parent_id) {
                        unset($location['parent_id']);
                        $location['children'] = build_tree($location['id'], $level+1);
                        $location['level'] = $level;
                        $location['href'] = 'locationview.php?location_id=' . $location['id'];
                        $children[] = $location;
                    }
                }
                return $children;
            }           
            $tree = build_tree(0, 0);
            $smarty->assign("locations", $tree);

	// end page
		// output
		$smarty->display("location.tpl");

		// footer
		include("footer.php");
?>