<?php
	/*****************************************************************************
	IP Reg, a PHP/MySQL IPAM tool
	Copyright (C) 2007-2009 Wietse Warendorff
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	For more information, visit http://sourceforge.net/projects/ipreg,
	or contact me at wietsew@users.sourceforge.net
	*****************************************************************************/
	
	// session
		// start session
		session_name('ipreg');
		session_start();

	// headers
		// raw http headers
		header("Content-Type: text/html; charset=utf-8"); 
	
	// includes
		// includes
		include("config.php");
		include("dbconnect.php");
		
		// load lib
		include("lib.php");
		
		// include language file
		$language = lang_getfrombrowser($config_lang, $config_lang_default, null, false);
		include('lang/' . $language . '.php');

	// try login?
		// check for submit
		if ($_SERVER['REQUEST_METHOD']=="POST" ) {
			/// get post info
			$user_name = sanitize($_POST['user_name']);
			$user_pass = sanitize($_POST['user_pass']);
			
			// login
			$login = $user->user_login($user_name, $user_pass);
			
			if($login==TRUE) {
				// redirect
				header_location("index.php");
			} else {
				// not ok, break session
				$_SESSION = array();
				session_destroy();
			}
		}
		
	// start output
		// get version for the footer-stamp
		$smarty->assign("config_version", $config_version);
		
		// set language variables
		$smarty->assign($lang);
	
	// end page
		// output
		$smarty->display("login.tpl");
		
		// end output
		include("footer.php");
?>