<?php
    /*****************************************************************************
    IP Reg, a PHP/MySQL IPAM tool
    Copyright (C) 2007-2009 Wietse Warendorff

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    For more information, visit http://sourceforge.net/projects/ipreg,
    or contact me at wietsew@users.sourceforge.net
    *****************************************************************************/

    // start page
        // includes
        include("includes.php");

        // start output
        include("header.php");

        // set language variables
        $smarty->assign($lang);

    // setup subnet
        // build query
        $query = "SELECT
                s.subnet_id,
                s.subnet_address,
                s.subnet_mask,
                s.ntp_server,
                LEFT(s.subnet_info, 40) AS subnet_info,
                CHAR_LENGTH(s.subnet_info) AS subnet_length,
                COUNT(node.subnet_id) AS node_counter
            FROM
                subnet AS s LEFT JOIN node USING (subnet_id)
            GROUP BY
                s.subnet_id
            ORDER BY
                INET_ATON(s.subnet_address)";

        // run query
        $subnets = $db->db_select($query);
        $smarty->assign("subnets", $subnets);

    // end page
        // output
        $smarty->display("subnet.tpl");

        // end output
        include("footer.php");
?>
